@import './medias';
@import './variables';
@import './animations';

@mixin ellipsis {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

@mixin flex-center-layout {
  display: flex;
  align-items: center;
  justify-content: center;
}

@mixin generic-layout($width: auto, $row: false) {
  box-sizing: border-box;
  width: $width;

  display: flex;
  @if $row {
    flex-direction: row;
    justify-content: flex-start;
    align-items: center;
  } @else {
    flex-direction: column;
    justify-content: center;
    align-items: flex-start;
  }
}

@mixin capitalize {
  text-transform: lowercase;
  &::first-letter {
    text-transform: uppercase;
  }
}

@mixin inner-neumorphism() {
  background: #222831;
  box-shadow: inset -10px -10px 30px rgba(238, 238, 238, 0.02), inset 10px 10px 10px rgba(0, 0, 0, 0.45);
  @include lt-md {
    box-shadow: inset -10px -10px 20px rgba(238, 238, 238, 0.02), inset 10px 10px 10px rgba(0, 0, 0, 0.45);
  }
}

@mixin outer-neumorphism() {
  background: #222831;
  box-shadow: -12px -12px 40px rgba(238, 238, 238, 0.07), 15px 15px 50px rgba(0, 0, 0, 0.45);
  @include lt-md {
    box-shadow: -7px -7px 20px rgba(238, 238, 238, 0.07), 10px 10px 20px rgba(0, 0, 0, 0.45);
  }
}

@mixin rainbow-link($background: true) {
  &:hover,
  &:active {
    @include border-rainbow($background);
  }
}

@mixin border-rainbow($background: true) {
  $border: 2px;
  position: relative;

  & > * {
    position: relative;
    z-index: 1;
  }

  &::before {
    content: '';
    position: absolute;
    z-index: 1;
    top: 0;
    left: 0;

    height: 100%;
    width: 100%;
    border-radius: inherit;

    box-shadow: inherit;
    background: inherit;
    background-blend-mode: inherit;
  }
  &::after {
    content: '';
    position: absolute;
    z-index: 0;
    top: calc(-1 * #{$border} / 2);
    left: calc(-1 * #{$border} / 2);

    height: calc(100% + #{$border});
    width: calc(100% + #{$border});
    border-radius: inherit;

    animation: rainbow 5s infinite ease;
  }

  @if ($background == false) {
    &::before {
      background: none;
    }
  }
}

@mixin background-gradient {
  background: $ghost-color1;
  background-image: linear-gradient(90deg, $ghost-color1 0px, $ghost-color2 50px, $ghost-color2 70px, $ghost-color1 80px);
  background-size: 80vw;
}

@mixin animate-ghost-line($animation-duration: 3000ms) {
  @include background-gradient;
  animation: ghostAnimation $animation-duration infinite linear;
}
